using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

// NOTE : this code is crap but you'll get the idea

namespace sharkex
{
    class Program
    {
        static Dictionary<int, string> zap;
        static int stringCount;
        
        static void Main(string[] args)
        {
            const string magic = "shark3d_snake_binary";
            
            foreach (string file in Directory.GetFiles(".","*.??r"))
                using (BinaryReader br = new BinaryReader(File.Open(file, FileMode.Open)))
                {
                    if (readStringBasic(br) == magic)
                    {
                        Console.WriteLine(file);
                        string version = readStringBasic(br);
                        zap = new Dictionary<int, string>();
                        stringCount = 0;
                        using (StreamWriter sw = new StreamWriter(file + ".txt"))
                        {
                            sw.WriteLine("translated shark3d binary -> version "+version);
                            readSub(br, sw, "");
                        }
                    }
                }
        }

        static void readSub(BinaryReader br, StreamWriter sw, string prefix)
        {
            int num = readNum(br);
            for (int i = 0; i < num; i++)
            {
                string name = readString(br);
                string line = prefix+name;
                int attachCode = br.ReadByte(), n;
                switch (attachCode)
                {
                    case 0:
                        sw.WriteLine(line + " = {}"); break;
                    case 1:
                        sw.WriteLine("{0} = {1:D}", line, readNum(br)); break;
                    case 2:
                        n = readNum(br);
                        line += " = {";
                        for (int e = 0; e < n; e++)
                        {
                            line += String.Format("{0},", readNum(br));
                            if (line.Length > 120)
                            {
                                sw.WriteLine(line);
                                line = prefix;
                            }
                        }
                        sw.WriteLine(line + "}");
                        break;
                    case 4:
                        sw.WriteLine("{0} = {1}", line, readFloat(br)); break;
                    case 8:
                        n = readNum(br);
                        line += " = {";
                        for (int e = 0; e < n; e++)
                        {
                            line += String.Format("{0},", readFloat(br));
                            if (line.Length > 120)
                            {
                                sw.WriteLine(line);
                                line = prefix;
                            }
                        }
                        sw.WriteLine(line + "}");
                        break;
                    case 0x10:
                        sw.WriteLine("{0} = {1}", line, readString(br)); break;
                    case 0x20:
                        n = readNum(br);
                        sw.WriteLine(line + " [");
                        for (int e = 0; e < n; e++)
                            sw.WriteLine(prefix + "  " + readString(br));
                        sw.WriteLine(prefix + " ]");
                        break;
                    case 0x40:
                        sw.WriteLine(line + " {");
                        readSub(br, sw, prefix + "  ");
                        sw.WriteLine(prefix + "}");
                        break;
                    case 0x80:
                        sw.WriteLine(line + " [");
                        n = readNum(br);
                        for (int e = 0; e < n; e++)
                        {
                            readSub(br, sw, prefix + "  ");
                            if (e<n-1)
                                sw.WriteLine(prefix + ",");
                        }
                        sw.WriteLine(prefix + "]");
                        break;
                    default:
                        sw.Close(); br.Close();
                        Console.WriteLine("Unrecognized code");
                        Console.ReadKey();
                        break;
                }
            }
        }

        static string readString(BinaryReader br)
        {
            int num = readNum(br);
            {
                int idx = stringCount - num;
                if (num==0)
                    stringCount++;
                if (zap.ContainsKey(idx))
                    return zap[idx];
                string ret = readStringBasic(br);
                zap.Add(idx, ret);
                return ret;
            }
        }

        static string readStringBasic(BinaryReader br)
        {
            char c;
            string ret="";
            while((c = br.ReadChar()) != 0)
                ret += c;
            return ret;
        }
        static int readNum(BinaryReader br)
        {
            int num = 0, n, shift = 0;
            do
            {
                n = br.ReadByte();
                num |= (n & 0x7f) << shift;
                shift += 7;
            } while (n >= 0x80);
            return num;
        }
        static float readFloat(BinaryReader br)
        {
            byte[] ar = new byte[4];
            for (int i = 0; i < 4; i++)
                ar[3 - i] = br.ReadByte();
            float f = BitConverter.ToSingle(ar, 0);
            return f;
        }

    }
}
